#!/usr/bin/Rscript

#codemrs<-ts(values[,3]/sum(values[,3]),start=startYear,freq=12)


do <- function(values, startYear, title, fname,maxy) {

   codemrs<-ts(values[,3],start=startYear,freq=12)
   codemrs.1<-filter(codemrs,filter=rep(1/10,10)) 

   funcmod<-ts(values[,4],start=startYear,freq=12)
   funcmod.1<-filter(funcmod,filter=rep(1/10,10)) 

   funcdiff<-ts((values[,5] - values[,6]),start=startYear,freq=12)
   funcdiff.1<-filter(funcdiff,filter=rep(1/10,10)) 

   funcadd<-ts(values[,5],start=startYear,freq=12)
   funcadd.1<-filter(funcadd,filter=rep(1/10,10)) 

#funcdel<-ts(values[,6]/sum(values[,6]),start=startYear,freq=12)
   funcdel<-ts(values[,6],start=startYear,freq=12)
   funcdel.1<-filter(funcdel,filter=rep(1/10,10)) 

   slocs<-ts(values[,7]/1000,start=startYear,freq=12)
   slocs.1<-filter(slocs,filter=rep(1/10,10)) 

   tfunctions<-ts(values[,8]/100,start=startYear,freq=12)
   tfunctions.1<-filter(tfunctions,filter=rep(1/10,10)) 


# plot it
   postscript(fname, width = 8.0, height=3.2, onefile = FALSE, paper = "special", horizontal= FALSE)

   plot(tfunctions.1, col=2,lty=3,,main="Code mrs and Function change activies for Apache",ann=FALSE,ylim=c(0,maxy),xlim=c(1998,2008))
   box()
   lines(codemrs.1, col=3,lty=2)
   lines(funcadd.1, col=6,lty=5)
   lines(funcdel.1, col=4,lty=6)
    lines(slocs.1, col=1,lty=1)
   lines(funcmod.1, col=1, lty=4)

   title(main=title,cex=0.7)
   title(xlab="Month")
   title(ylab="Total Activity")

   legend("topright",c("kSLOCs", "CodeMRs","Total Functions/100", "Functions Modified", "Functions Added", "Functions Deleted"),  col=c(1,3,2,1,6,4),lty=c(1,2,3,4,5,6),cex=0.65)
   dev.off()
}

#apache 1996
#evolution1998

evolution<-read.table("../data/Evolution/permonth.txt", head=TRUE,sep="|");

do(evolution, 1998, "Project Activity by Month (Evolution)", "evolutionPerMonth.eps",1200)

apache<-read.table("../data/Apache/permonth.txt", head=TRUE,sep="|");

do(apache, 1998, "Project Activity by Month (Apache)", "apachePerMonth.eps",350)

