-- find last revision of only current c files

create temp table lastrev as  select filename, revid from currentfiles natural join (select filename, max( to_number(revid,'99999999999')) as revid from revisions group by filename) as rip;

create temp table firstrev as  select * from currentfiles natural join (select filename, min(to_number(revid,'99999999999')) as revid from revisions group by filename) as rip;


-- what are the functions in the lastrev?

create temp table currentfunc as select filename, function from funcmod natural join lastrev;
create temp table firstfunc as select filename, function from funcmod natural join firstrev;

-- find revisions that add and delete functions
create temp table revadd as select distinct revid from funcmod where typemod = 'A';
create temp table revdel as select distinct revid from funcmod where typemod = 'D';

--this are the revisions that add and remove
create temp table revaddanddel as select * from revadd intersect select * from revdel;

-- find the functions added in this revisions
create temp table funcaddanddel as select filename, function from funcmod natural join revaddanddel where typemod in ('A', 'D');

--now find revisions that add too many functions (> 10)

create temp table toomany as select revid from funcmod where typemod = 'A' group by revid having count(*) > 10 ;
create temp table functoomany as select filename, function from funcmod natural join toomany where typemod in ('A');

-- find functions that had the same name and were removed before

create temp table funcremovedbefore as select distinct function from currentfunc intersect select function from funcmod where typemod = 'D';

create temp table funcremoved as select filename, function from currentfunc natural join funcremovedbefore;

-- now union all these functions

create temp table funcdontuse as select * from functoomany union select * from funcaddanddel union select * from funcremoved union select * from firstfunc;


create temp table goodfunc as select distinct filename, function, 1 as good from currentfunc except select *,1 from funcdontuse;

--functions that have never been modified after they are added

create temp table goodnevermodified as select * from currentfunc natural join funcmod natural join (select filename, function from funcmod natural join goodfunc where typemod = 'A' except select filename, function from funcmod natural join goodfunc where typemod in ('M','D')) as rip where typemod = 'A' ;


-------------- Work with goos

-- authors of a function

 create temp table authorsgoods as select filename, function, count(distinct author) as authors from (select distinct filename, function,  author from funcmod natural join goodfunc where typemod in ('A','M','D')) as rip group by filename, function;


-- number of changes of a function
create temp table changesgoods as select filename, function, count(*) as changes from (select filename, function from funcmod natural join goodfunc where typemod in ('A','M','D')) as rip group by filename, function;


create temp table countsgoods as select * from changesgoods natural full join authorsgoods;

--select * from countsgoods;

-- authors of a function

create temp table authorsall as select filename, function, count(distinct author) as authors from (select distinct filename, function,  author from funcmod where typemod in ('A','M','D')) as rip group by filename, function;


-- number of changes of a function
create temp table changesall as select filename, function, count(*) as changes from (select filename, function from funcmod  where typemod in ('A','M','D')) as rip group by filename, function;

create temp table changesallM as select filename, function, count(*) as mods from (select filename, function from funcmod  where typemod in ('M')) as rip group by filename, function;

create temp table changesallD as select filename, function, count(*) as deleted from (select filename, function from funcmod  where typemod in ('D')) as rip group by filename, function;


create temp table countsalls as select * from changesall natural full join authorsall;

--select * from countsgoods;

create temp table lastsizecurrent as select distinct filename, function, sizeafter as lastsize from (select * from funcmod where  typemod <> 'D') as rip natural join  lastrev;

create temp table sizevschanges as select * from changesall natural join lastsize natural join authorsall;


create temp table sizevschangesgood as select * from changesgoods natural join lastsize natural join authorsall;


--this gives me authors per line
-- select sizeafter as lines, avg(authors)  from sizevschangesgood group by sizeafter order by sizeafter;

-- now create a temp table to be able to track frequency of functions with 1 author and modifiicatons
create temp table authorsfreqfuncA as select authors, count(*) as freq from countsalls group by authors;
create temp table changesfreqfuncA as select changes, count(*) as freq from countsalls group by changes;


create temp table authorsfreqfuncG as select authors, count(*) as freqgood from countsgoods group by authors;
create temp table changesfreqfuncG as select changes, count(*) as freqgood from countsgoods group by changes;

create temp table authorsfreq as select * from authorsfreqfuncA natural join authorsfreqfuncG;
create temp table changesfreq as select * from changesfreqfuncA natural join changesfreqfuncG;


----------------------------------------------------------------------
--last size of all functions (before they are deleted)
-- find first 
drop table funclastrev;
create temp table funclastrev as select filename, function, max(revid) as revid from funcmod where typemod not  in ('D','I') group by filename, function; 
drop table lastsize;
create temp table lastsize as select distinct filename, function, sizeafter as lastsize from (select * from funcmod where  typemod <> 'D') as rip natural join  funclastrev;

