#!/usr/bin/Rscript

project <- commandArgs(TRUE)[1];

name <- paste("../data/", project, "/statsFunctions.txt",sep="");

a <- read.table(name,sep="|",header=TRUE)

d<-a[,13]
deleted<-a[,5]
good<-a[,11]

title <- "Days to last change"
xlabel = "Days passed from function creation to last change"
ylabel = "Proportion of functions"

title <- paste(title, "\n(", project, ")",sep="")

h <- hist(d[deleted==0],breaks=50)
h2<- hist(d[deleted==0 && good==1],breaks=50)
fname1 <- paste(project, "All-line.eps",sep="")
fname2 <- paste(project, "All-bar.eps",sep="")

postscript(fname1, width = 5.0, height=5.0, onefile = FALSE, paper = "special", horizontal= FALSE)
plot(h2$mids, h2$counts/sum(h2$counts),type="l",main=title,xlab=xlabel,ylab=ylabel,col=1,lty=1,log="x")   
lines(h$mids, h$counts/sum(h$counts),type="l",col=2,lty=2)
legend("topright",c("All functions","Selected functions"),  col=c(2,1),lty=c(2,1))
dev.off()

postscript(fname2, width = 5.0, height=5.0, onefile = FALSE, paper = "special", horizontal= FALSE)
x <- d[deleted==0];
h <- hist(x,prob=T,breaks=20);
ylim <- range(h$density);
lines(density(x),col="red",lwd=3)
legend("topright",c("All functions","Selected functions"),  col=c(2,1),lty=c(2,1))
dev.off()



#do(h$mids, h$counts/sum(h$counts),main=title, xlab=x, ylab=ylabel,type="l")

# h<-hist(d[deleted==0])
#> plot(h$mids, h$counts/sum(h$counts),type="l")

#plot(x,y,log="xy",main=title,xlab=xlabel,ylab=ylabel)   


#do <- function(x, y,title,fname,project,xlabel,ylabel) {
#   title <- paste(title, "\n(", project, ")",sep="")
#
#   all <- cor(x,y,method="spearman")
#   less5 <- cor(x[x<=5],y[x<=5],method="spearman")
#   less10 <- cor(x[x<=10],y[x<=10],method="spearman")
#   more10 <- cor(x[x>10],y[x>10],method="spearman")
#   more5 <- cor(x[x>5],y[x>5],method="spearman")
##    all <- 1;
##    less5 <- 1;
##    more5 <- 1;
###    less10 <- 1;
##    more10 <- 1;
#   postscript(fname, width = 5.0, height=5.0, onefile = FALSE, paper = "special", horizontal= FALSE)
#   plot(x,y,log="xy",main=title,xlab=xlabel,ylab=ylabel)   
#   dev.off()
#   c(all,less5,more5,less10,more10)
#}
#
#
#filename <- paste(args, "All.eps",sep="")
#
#do(changes, sizes, "Changes vs Size of All Functions",filename,args,"Number of Changes (log)","Size of Functions (log)")
#
#cg <- changes[good>0]
#sg <- sizes[good>0]
#
#filename <- paste(args, "Selected.eps",sep="")
#do(cg,sg, "Changes vs Size of Selected Functions", filename,args,"Number of Changes (log)","Number of Functions (log)")
#
#
#filename <- paste(args, "AuthorsAll.eps",sep="")
#do(changes, authors, "Changes vs Size of Selected Functions", filename,args,"Number of Changes (log)","Number of different authors (log)")
#
#ag <- authors[good>0]
#
#filename <- paste(args, "AuthorsSelected.eps",sep="")
#do(cg, ag, "Changes vs Size of Selected Functions", filename,args,"Number of Changes (log)","Number of different authors (log)")
#
#
#
