#!/usr/bin/Rscript
args <- commandArgs(TRUE)
values = read.table("/tmp/permr.txt",sep="|",header=TRUE)

added=values[,2]
mod=values[,3]
del=values[,4]
files=values[,5]
totalfunc=added+mod+del


postscript("permr.eps", width = 5.0, height=5.0, onefile = FALSE, paper = "special", horizontal= FALSE)

plot(files, totalfunc+1, log="xy",axes=FALSE, ann=FALSE)
title(xlab="Number of Files in CodeMR")
title(ylab="Total Altered Functions (Mod + Add + Del)")

t <- paste("Files vs Total Altered Functions (", args, ")");
title(main=t)
#title(main=t)
axis(2, at=c(1,6,11,101,1001),labels=c('0','5','10','100','1000'))
axis(1, at=c(1,5,10,100,1000),labels=c('1','5','10','100','1000'))


dev.off()



