#!/usr/bin/Rscript

args <- commandArgs(TRUE)[1];

name <- paste("../data/", args, "/statsFunctions.txt",sep="");

a <- read.table(name,sep="|",header=TRUE)


changes<-a[,7]+1
sizes<-a[,6]
authors<-a[,3]
good<-a[,11]

do <- function(x, y,title,fname,project,xlabel,ylabel) {
   title <- paste(title, "\n(", project, ")",sep="")

   all <- cor(x,y,method="spearman")
   less5 <- cor(x[x<=5],y[x<=5],method="spearman")
   less10 <- cor(x[x<=10],y[x<=10],method="spearman")
   more10 <- cor(x[x>10],y[x>10],method="spearman")
   more5 <- cor(x[x>5],y[x>5],method="spearman")
#    all <- 1;
#    less5 <- 1;
#    more5 <- 1;
##    less10 <- 1;
#    more10 <- 1;
   postscript(fname, width = 5.0, height=5.0, onefile = FALSE, paper = "special", horizontal= FALSE)
   plot(x,y,log="xy",main=title,xlab=xlabel,ylab=ylabel)   
   dev.off()
   c(all,less5,more5,less10,more10)
}


filename <- paste(args, "All.eps",sep="")

do(changes, sizes, "Changes vs Size of All Functions",filename,args,"Number of Changes (log)","Size of Functions (log)")

cg <- changes[good>0]
sg <- sizes[good>0]

filename <- paste(args, "Selected.eps",sep="")
do(cg,sg, "Changes vs Size of Selected Functions", filename,args,"Number of Changes (log)","Number of Functions (log)")


filename <- paste(args, "AuthorsAll.eps",sep="")
do(changes, authors, "Changes vs Size of Selected Functions", filename,args,"Number of Changes (log)","Number of different authors (log)")

ag <- authors[good>0]

filename <- paste(args, "AuthorsSelected.eps",sep="")
do(cg, ag, "Changes vs Size of Selected Functions", filename,args,"Number of Changes (log)","Number of different authors (log)")


